# Generated by rust2rpm 24
%bcond_without check

%global crate notification-emitter

Name:           qubes-notification
Version:        1.0.1
Release:        1%{?dist}
Summary:        Notification proxy for Qubes OS

License:        GPLv2+
URL:            https://www.qubes-os.org/
Source:         notification-emitter.tar.gz

BuildRequires:  rust-packaging >= 23
# FIXME: specify version
BuildRequires:  systemd-rpm-macros

%global _description %{expand:
Notification proxy for Qubes OS.}

%description %{_description}

%package     -n %{crate}
Summary:        %{summary}
# FIXME: paste output of %%cargo_license_summary here
License:        GPLv2+
# LICENSE.dependencies contains a full license breakdown
BuildRequires:  qubes-utils-devel

%description -n %{crate} %{_description}

%package        devel
Summary:        %{summary}
BuildArch:      noarch

%description    devel %{_description}

This package contains library source intended for building other packages which
use the "%{crate}" crate.

%package        agent
Summary:        Guest-side part of the notification proxy
Provides:       desktop-notification-daemon
%description    agent
Qubes OS includes a proxy for the FreeDesktop.org notification
protocol.  This package provides the guest part of the proxy,
which forwards notifications from guest processes to the host.

%post agent
%systemd_user_post qubes-notification-agent.service

%preun agent
%systemd_user_preun qubes-notification-agent.service

%files agent
%{_bindir}/qubes-notification-proxy-client
%_userunitdir/qubes-notification-agent.service
%_userpresetdir/90-qubes-notification-agent.preset

%package        daemon
Summary:        Host-side part of the notification proxy
Requires:       %{name}-license

%description daemon
Qubes OS includes a proxy for the FreeDesktop.org notification
protocol.  This package provides the host part of the proxy, which
forwards notifications to the host's notification daemon.

%files daemon
%{_bindir}/qubes-notification-proxy-server
/etc/qubes-rpc/qubes.Notifications

%package        license
Summary:        License files for the notification proxy

%description license
License files for the notification proxy

%files license
# FIXME
%license /usr/share/licenses/qubes-notification-proxy/LICENSE.dependencies

%prep
%autosetup -n %{crate} -p1
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires

%build
%cargo_build
%{cargo_license_summary}
%{cargo_license} > LICENSE.dependencies

%install
install -d -- "$RPM_BUILD_ROOT/etc/qubes-rpc/" "$RPM_BUILD_ROOT/%_userunitdir" "$RPM_BUILD_ROOT/%_userpresetdir"
install -m0644 -- src/qubes-notification-agent.service "$RPM_BUILD_ROOT/%_userunitdir"
install -m0644 -- src/90-qubes-notification-agent.preset "$RPM_BUILD_ROOT/%_userpresetdir"
install -D -- target/release/notification-proxy-client "$RPM_BUILD_ROOT/%_bindir/qubes-notification-proxy-client"
install -D -- target/release/notification-proxy-server "$RPM_BUILD_ROOT/%_bindir/qubes-notification-proxy-server"
ln -s -- ../../usr/bin/qubes-notification-proxy-server "$RPM_BUILD_ROOT/etc/qubes-rpc/qubes.Notifications"
install -m0644 -D -- LICENSE.dependencies "$RPM_BUILD_ROOT/usr/share/licenses/qubes-notification-proxy/LICENSE.dependencies"

%if %{with check}
%check
%cargo_test
%endif

%changelog
* Thu Apr 04 2024 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-notification-proxy.git

* Thu Apr 04 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 0370c62
- version 1.0.1

* Thu Apr 04 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 67b6306
- Lower required nix package version

* Wed Apr 03 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d0259ec
- ci: add config

* Wed Apr 03 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 408a004
- spec: add missing dist suffix

* Wed Apr 03 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 83b47e4
- Fix .qubesbuilder file for debian

* Wed Mar 27 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f429ea6
- version 1.0.0

* Wed Mar 27 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c95dff8
- spec: do not use autorelease feature

* Fri Mar 08 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - ce31c53
- Avoid more log spam

* Fri Mar 08 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 093162a
- Fix bugs found by Marek's testing

* Tue Mar 05 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 7c4fbd6
- Add missing file

* Tue Feb 20 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - ee9fd83
- Add tests for image validation

* Tue Feb 20 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - cb29971
- Another build fix

* Mon Feb 19 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 2978a1c
- Test for string santization

* Mon Feb 19 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - be24989
- Handle notification daemon restart

* Mon Feb 19 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 03e46ad
- Implement resident hint

* Sun Feb 18 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 51fcf7f
- Disable icon-data hint

* Sun Feb 18 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 01834f1
- Implement ID translation

* Sun Feb 18 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 5956ce1
- Fix compile failure

* Thu Feb 08 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - bee78c5
- Limit categories to 64 bytes

* Fri Jan 19 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7b06d02
- Fix file permissions in RPM

* Fri Jan 19 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ee7426d
- Fix debian packaging

* Mon Dec 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 659c6b0
- Implement versioning of notifications

* Sat Dec 09 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 0232e34
- Implement version negotiation

* Fri Dec 08 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 14adec1
- Rip out Cargo.lock

* Mon Nov 27 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 71fd25b
- Much better text sanitization

* Sun Nov 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 432a14d
- Strictly validate action names

* Sun Nov 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 420c937
- Require actions array to have even length

* Sun Nov 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - c862bf7
- Do not prefix a used variable with an underscore

* Sun Nov 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 3739970
- Recognize KDE inline-reply extension

* Sun Nov 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 14f0563
- Recognize more server capabilities

* Sun Nov 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 43aca74
- Send an application name

* Sun Nov 26 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - aef05f6
- Conflict with xfce4-notifyd

* Sat Nov 25 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 347be54
- fix file name

* Sat Nov 25 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - e4a033a
- packaging fix

* Sat Nov 25 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 8d8ef9c
- packaging fix

* Sat Nov 25 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - f4af787
- Enable notifications by default

* Wed Nov 22 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - b66d9b6
- Add prefix and fix packaging

* Tue Nov 21 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 1f6cf7b
- Respect the notification server's capabilities

* Tue Nov 21 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 7e87c8a
- Install qubes.Notifications symbolic link

* Tue Nov 21 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 0488d4d
- Use U+FFFD REPLACEMENT CHARACTER

* Mon Nov 20 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 0cbb7eb
- Sanitize strings

* Tue Oct 31 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 3807a32
- Drop junk from Cargo.lock

* Wed Oct 18 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 494ec9b
- Fix trailing whitespace in .qubesbuilder

* Sun Sep 24 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - aafd3d5
- Fix silly YAML error in .qubesbuilder

* Sun Sep 24 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 70a09b3
- Fix RPM package build

* Sun Sep 24 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - b69d9ad
- Debian packaging

* Sun Sep 24 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - f625323
- builderv2 integration

* Sun Sep 24 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 3ec1f0b
- Move contents of notification-emitter/ to root

* Wed Aug 30 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 9812fae
- Implement some error handling

* Tue Aug 29 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - d476ccc
- Support invoking actions

